var amountScrolled = 100;
var showHideBttnScrollOffset = 90;
var dfltAnimateDuration = 900;
var scrollToAnchorAnimateDuration = 900;
var focusScrollAnimateDuration = 0;
var strPressEnterToExpand = "Show";
var strPressEnterToCollapse = "Hide";
var strBackToTop = "Back to Top"; 
var strContentsHideBttnTxt = "Hide Contents";
var strContentsShowBttnTxt = "Show Contents";
var srcEventPageY = 0;

$(document).ready(function (){
    $('iframe').each(function(){
        var url = $(this).attr("src");
        $(this).attr("src",url+"?wmode=transparent");
    });
    
    $('button.showhide').append("<span class=\"toggletext\">"
				+ strPressEnterToExpand + "</span>");

    $('button.showhide').on('click', function(){
	var divID = $(this).attr("aria-controls");
	$("#" + divID).toggle();
	changeHideShow(this);
    });
    addSpan2Back2Top();

    /** Window/Scroll **/
    $(window).scroll(function() {
	if ( $(window).scrollTop() > amountScrolled ) {
	    $('a.back-to-top').fadeIn('slow');
	} else {
	    $('a.back-to-top').fadeOut('slow');
	}
    });

    $(window).scroll(function() { 
	var scroll = $(window).scrollTop();
	if (scroll > 0) {
            $("#logo").addClass("active");
	}else{
            $("#logo").removeClass("active");
	}

    });
    $("#menu-trigger").on("click", function(){
	showHideMenu();});
    $("a").on("click",function(){	
	var href = $(this).attr("href");
	if(href.charAt(0) == '#'){
	  scrollToAnchor($(href));
	}
    });
    $(window).bind('hashchange', function() {
	expandSection4Anchor();
	var p = window.location.href.lastIndexOf("#");
	var urlhash = null;	
	if(p >= 0){
	    urlhash = window.location.href.substr(p);
	    scrollToAnchor($(urlhash));
	}
    });
    $('area').bind('click', function(event) {
	var p = window.location.href.lastIndexOf("#");
	var urlhash = null;
	srcEventPageY = event.pageY;
	if(p >= 0){
	    urlhash = window.location.href.substr(p);
	    if(urlhash == $(this).attr("href")){
		expandSection4Anchor();
		scrollToAnchor($(urlhash));
	    }
	}
    });
    $("a[href],button,input"
     ).on("focus",function(){
	 scrollDownAnchorByFocus($(this));
	 //scrollToFocus($(this));
     });
    initShowHideMenuButton();
    if(!isTouchDevice()){
	$("body").append("<div class=\"tooltip\" id=\"id_tooltip\"><p id=\"id_p_tooltip\"/></div>");
	$("#id_tooltip").hide();	
	$('area').mouseover(function(event) {
	    $("#id_tooltip").show();
	    $("#id_p_tooltip").replaceWith("<p id=\"id_p_tooltip\">" + 
					   $(this).attr('alt') + "</p>");
	    $("#id_tooltip").animate({
		left: event.pageX,
		top: event.pageY
	    }, 0, function() {
	    // Animation complete.
	    });
	    
	}).mouseout(function(){
	    //console.log('Mouseout....'); 
	    $("#id_tooltip").hide();
	    
	}).mousemove(function(event) {
	    var hoverPara = getHoverPara(this)
	    $("#id_p_tooltip").replaceWith(hoverPara);
	    $("#id_tooltip").animate({
		left: event.pageX,
		top: event.pageY
	    }, 0, function() {
		// Animation complete.
	});
	});
    }
    var p = top.location.href.lastIndexOf('#');
    if(p >= 0){
	urlhash = window.location.href.substr(p);
	expandSection4Anchor();
	scrollToAnchor($(urlhash));
    }
});

function scrollDownAnchorByFocus(elm){ 
    var top = $(elm).offset().top;
    var headerTop = $("#logo").offset().top;
    var headerHeight =  $("#logo").height();
    if(top <  (headerTop + headerHeight)){
	$('html, body').animate(
	    {
		scrollTop:  elm.offset().top - showHideBttnScrollOffset
	    }, dfltAnimateDuration);
    }
} 


function initShowHideMenuButton(){
    $("#menu-trigger").append("<span class=\"PTTRANSPARENT\"></span>");
    hideMenu();
}


function showHideBttnScroll(elm){
    $('html, body').animate(
	{
            scrollTop: $(elm).offset().top - showHideBttnScrollOffset
	}, dfltAnimateDuration);
    return false;
}

function scrollToAnchor(elm){
    $(this).scrollTop(srcEventPageY);
    $('html, body').animate(
	{
            scrollTop: $(elm).offset().top - showHideBttnScrollOffset
	}, scrollToAnchorAnimateDuration);
    return false;
}


function addSpan2Back2Top(){
    $("a.back-to-top").attr("role", "button");
    $("a.back-to-top").append("<span class=\"PTTRANSPARENT\">" + strBackToTop +
			      "</span>");
    $("a.back-to-top").on("click", function(){
	$('html, body').animate({
            scrollTop: showHideBttnScrollOffset
	}, dfltAnimateDuration);
    });
    return false;

}

function showHideMenu(){
    if($("#menucontainer").is(":visible")){
	hideMenu();
    }else{
	showMenu();
    }
}

function showMenu(){
    $("#menucontainer").show();
    $("#menu-trigger").removeClass("hamburger-menu");
    $("#menu-trigger").addClass("menu-close-button");
    $("#menu-trigger span").text(strContentsHideBttnTxt);
    $("#menu-trigger").attr("title",strContentsHideBttnTxt);
}

function hideMenu(){
    $("#menucontainer").hide();
    $("#menu-trigger").removeClass("menu-close-button");
    $("#menu-trigger").addClass("hamburger-menu");
    $("#menu-trigger span").text(strContentsShowBttnTxt);
    $("#menu-trigger").attr("title",strContentsShowBttnTxt);
}

function expandSection4Anchor(){
    var href = document.location.href;
    var p = href.indexOf("#");
    var anchor = null;
    var anchorParentDiv = null;
    anchor = getAnchor();
    if(anchor != null){
	var buttonParentDiv =$("#" + anchor).closest("div.boxfull").first()
	    .prev();	
	var button = buttonParentDiv.find("h2 > button");
	var idContent = $(button).attr("aria-controls");
	if(idContent !== undefined){
	    var idCntnts = idContent.split(" ");
	    for(var id in idCntnts){
		var divContent = $("#" + idCntnts[id]);
		expandSubtopic(divContent, button);	    
	    }
	    location.hash = '#' + anchor;
	}
    }
}

function getAnchor(){
   var href = document.location.href;
    var p = href.indexOf("#");
    var anchor = null;
    var anchorParentDiv = null;
    if(p >= 0){
	anchor = href.substr(++p);
	var q = -1;
	if((q = anchor.indexOf('?')) > 0){
	    anchor = anchor.substr(0, q);
	} 
	return anchor;
    }
    return null;
}

function expandSubtopic(divContent, button){
    if(!$(divContent).is(":visible")){
	$(divContent).show();
	changeHideShow(button);
    }
}

function changeHideShow(button){
    var divID = $(button).attr("aria-controls");
    if( $("#" + divID).is(":hidden") ){
	$("#" + divID).attr("aria-expanded", "false");
	$(button).find("img").attr("src", "images/arrow_on.svg");
	$(button).find("span:last-child").html(strPressEnterToExpand);
    }else{
	$("#" + divID).attr("aria-expanded", "true");
	$(button).find("img").attr("src", "images/arrow_off.svg");
	$(button).find("span:last-child").html(strPressEnterToCollapse);
	showHideBttnScroll(button);
    }
}


function isTouchDevice(){
    return typeof window.ontouchstart !== 'undefined';
}


function getHoverPara(area){
	var hoverPara = "<p id=\"id_p_tooltip\">" +
	    (isTouchDevice() ? "<a href=\"" + $(area).attr('href') + "\">" :"") +
	    $(area).attr('alt') + 
	    (isTouchDevice() ? "</a>" : "") +
	    "</p>";
    return  hoverPara;
}